#line 1 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/CC3000.c"
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/cc3000.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 21 "c:/arm projects/mikromedia 5 for tiva/wifi/cc3000.h"
void DispDHCP(void);
void DispSocket(void);
void DispSSID(void);
void DispVer(void);

void SPI1_Initialize(void);




void InitTimer0A(void);
int32_t Net_Wireless_CC3000_WaitHandler();
void WiFi_Polling(void);
void Net_Wireless_CC3000_UsynchCallback(int32_t eventType, uint8_t *dat, uint8_t length);

void WiFi_StateMachine(void);
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/built_in.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/__net_wireless_cc3000.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 56 "c:/arm projects/mikromedia 5 for tiva/wifi/__net_wireless_cc3000.h"
typedef struct
{
 uint8_t aucIP[4];
 uint8_t aucSubnetMask[4];
 uint8_t aucDefaultGateway[4];
 uint8_t aucDHCPServer[4];
 uint8_t aucDNSServer[4];
 uint8_t uaMacAddr[6];
 uint8_t uaSSID[32];
}tNetappIpconfigRetArgs;

typedef struct
{
 uint32_t packets_sent;
 uint32_t packets_received;
 uint32_t min_round_time;
 uint32_t max_round_time;
 uint32_t avg_round_time;
} tNetappPingreportRetArgs;

typedef struct {
 uint8_t status;
 uint16_t netIndex;
 int8_t rssi;
 uint8_t securityMode;
 uint8_t ssidNameLength;
 uint8_t ssidName[32];
 uint8_t bssid[6];
} tScanResult;

typedef void (*tWlanCB)(int32_t eventType, uint8_t * dat, uint8_t length );
extern int32_t Net_Wireless_CC3000_WaitHandler();
#line 136 "c:/arm projects/mikromedia 5 for tiva/wifi/__net_wireless_cc3000.h"
typedef struct
{
 uint16_t sa_family;
 uint8_t sa_data[14];
} tSockAddr;

typedef struct
{
 uint32_t s_addr;
} tIn_addr;

typedef struct
{
 int16_t sin_family;
 uint16_t sin_port;
 tIn_addr sin_addr;
 uint8_t sin_zero[8];
} tSockaddr_in;


typedef int32_t __fd_mask;
typedef struct
{
 __fd_mask fds_bits[ 32  /  (8 * sizeof (__fd_mask)) ];
} tFd_set;

typedef int32_t tTime;
typedef int32_t tSuseconds;
typedef struct
{
 tTime tv_sec;
 tSuseconds tv_usec;
} tTimeval;
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/common.h"
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/buffers.h"
#line 13 "c:/arm projects/mikromedia 5 for tiva/wifi/buffers.h"
char* GetBuffer(void);
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/uart1.h"
#line 21 "c:/arm projects/mikromedia 5 for tiva/wifi/uart1.h"
typedef void (* tPointerFcn)(void);



void UART1_Enable(void);
void UART1_StartRx(void);
void UART1_StartTx(void);
char UART1_CheckFree(void);

void UART1_Initialize(void);
void UART1_RxQueueInit(void);
char UART1_GetChar(char *rxbyte);
void UART1_Rx(void);
void UART1_Rx1(void);
void UART1_Rx2(void);

void UART1_TxQueueInit(void);
void UART1_PutQueue(char *msg);
void UART1_SendMsg(char *s);
void UART1_Tx(void);
void UART1_Tx1(void);
void UART1_Send(char *s);
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/__time.h"
#line 30 "c:/arm projects/mikromedia 5 for tiva/wifi/__time.h"
typedef struct
{
 unsigned char ss;
 unsigned char mn;
 unsigned char hh;
 unsigned char md;
 unsigned char wd;
 unsigned char mo;
 unsigned int yy;
} TimeStruct ;
#line 44 "c:/arm projects/mikromedia 5 for tiva/wifi/__time.h"
extern long Time_jd1970;
#line 49 "c:/arm projects/mikromedia 5 for tiva/wifi/__time.h"
long Time_dateToEpoch(TimeStruct *ts);
long Time_dateDiff(TimeStruct *t1, TimeStruct *t2);
void Time_epochToDate(long e, TimeStruct *ts);
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/led.h"
#line 13 "c:/arm projects/mikromedia 5 for tiva/wifi/led.h"
void LED_Initialize(void);

void LED_Set_Red(void);
void LED_Clr_Red(void);
void LED_Set_Green(void);
void LED_Clr_Green(void);
void LED_Set_Blue(void);
void LED_Clr_Blue(void);
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
#line 11 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
void TimerInit(void);
void TimerCheck(void);
#line 33 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
struct timers {
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 45 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
void init_timerpool(void);
#line 54 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
unsigned short int get_timer(void);
#line 64 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 73 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
unsigned long int check_timer(unsigned short int nbr);
#line 82 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
void free_timer(unsigned short int nbr);
#line 91 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
void irqhandler_timer(void);
#line 23 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/CC3000.c"
sfr sbit Net_Wireless_CC3000_CS at GPIO_PORTB_AHB_DATA.B4;
sfr sbit Net_Wireless_CC3000_Int at GPIO_PORTB_AHB_DATA.B2;
sfr sbit Net_Wireless_CC3000_En at GPIO_PORTF_AHB_DATA.B5;

sfr sbit Net_Wireless_CC3000_CS_Direction at GPIO_PORTB_AHB_DIR.B4;
sfr sbit Net_Wireless_CC3000_Int_Direction at GPIO_PORTB_AHB_DIR.B2;
sfr sbit Net_Wireless_CC3000_En_Direction at GPIO_PORTF_AHB_DIR.B5;




const int8_t WIFI_SUCCESS = 0;
const int8_t WIFI_ERROR = -1;
const uint16_t localPort = 1234;




uint8_t ssid[32] = "Hitron";
uint8_t key[] = "NewGen7of9";


uint8_t AltSSID[6] = {0x48,0x69,0x74,0x72,0x6F,0x6E};
uint8_t AltKey[10] = {0x4E,0x65,0x77,0x47,0x65,0x6E,0x37,0x6F,0x66,0x39};
uint8_t AltBSSID[6] = {0x00,0x00,0x00,0x00,0x00,0x00};

uint8_t myMacAddr[6] = {0x00,0x14,0xA5,0x76,0x19,0x3f};
uint32_t myIpAddr[4] = {0,0,0,0};
uint32_t gwIpAddr[4] = {0,0,0,0};
uint32_t ipMask[4] = {0,0,0,0};
uint32_t dnsIpAddr[4] = {0,0,0,0};

uint8_t timeServer[] = "time-a.nist.gov";

uint8_t remoteIpAddr[4] = {0,0,0,0};
int16_t remotePort = 37;

int32_t clientSock;

uint32_t connectedFlag, dhcpCompleteFlag;
uint32_t finReceive, sockOptValue;

uint32_t timeOutCnt;
tSockAddr localSockAddr, remoteSockAddr;


tNetappIpconfigRetArgs MyConfiguration;

uint8_t dataBuff[ 1400 ];
uint8_t State = 0;

uint32_t timeServIpAddr[1];

int32_t RetVal;
int32_t numOfRcvBytes;
long epoch;
TimeStruct my_time;
uint8_t ObtainedTime =  0 ;

uint8_t TestIP_Addr[4];
uint16_t TestPort[2];
tSockAddr TestSocketAddress;
tScanResult TestScan;

uint8_t WiFiTimer;
uint8_t NVMEM[68];

uint32_t Counter;

extern char TxIn;
extern char TxOut;
#line 100 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/CC3000.c"
void DispDHCP(void){
 char *BufNum;


 void Net_Wireless_CC3000_GetIpConfig(tNetappIpconfigRetArgs MyConfiguration);

 BufNum = GetBuffer();
 sprintf(BufNum,"aucIP:              %d.%d.%d.%d\r\n",MyConfiguration.aucIP[0],MyConfiguration.aucIP[1],
 MyConfiguration.aucIP[2],MyConfiguration.aucIP[3]);
 UART1_PutQueue(BufNum);

 BufNum = GetBuffer();
 sprintf(BufNum,"aucSubnetMask:      %d.%d.%d.%d\r\n",MyConfiguration.aucSubnetMask[0],MyConfiguration.aucSubnetMask[1],
 MyConfiguration.aucSubnetMask[2],MyConfiguration.aucSubnetMask[3]);
 UART1_PutQueue(BufNum);

 BufNum = GetBuffer();
 sprintf(BufNum,"aucDefaultGateway:  %d.%d.%d.%d\r\n",MyConfiguration.aucDefaultGateway[0],MyConfiguration.aucDefaultGateway[1],
 MyConfiguration.aucDefaultGateway[2],MyConfiguration.aucDefaultGateway[3]);
 UART1_PutQueue(BufNum);

 BufNum = GetBuffer();
 sprintf(BufNum,"aucDHCPServer:      %d.%d.%d.%d\r\n",MyConfiguration.aucDHCPServer[0],MyConfiguration.aucDHCPServer[1],
 MyConfiguration.aucDHCPServer[2],MyConfiguration.aucDHCPServer[3]);
 UART1_PutQueue(BufNum);

 BufNum = GetBuffer();
 sprintf(BufNum,"aucDNSServer:       %d.%d.%d.%d\r\n",MyConfiguration.aucDNSServer[0],MyConfiguration.aucDNSServer[1],
 MyConfiguration.aucDNSServer[2],MyConfiguration.aucDNSServer[3]);
 UART1_PutQueue(BufNum);

 BufNum = GetBuffer();
 sprintf(BufNum,"uaMacAddr:          %d.%d.%d.%d\r\n",MyConfiguration.uaMacAddr[0],MyConfiguration.uaMacAddr[1],
 MyConfiguration.uaMacAddr[2],MyConfiguration.uaMacAddr[3],
 MyConfiguration.uaMacAddr[4],MyConfiguration.uaMacAddr[5]);
 UART1_PutQueue(BufNum);

 BufNum = GetBuffer();
 sprintf(BufNum,"uaSSID:             %d.%d.%d.%d\r\n",MyConfiguration.uaSSID[0],MyConfiguration.uaSSID[1],
 MyConfiguration.uaSSID[2],MyConfiguration.uaSSID[3],
 MyConfiguration.uaSSID[4]);
 UART1_PutQueue(BufNum);
}
#line 147 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/CC3000.c"
void DispSocket(void) {
 char *BufNum;

 RetVal = Net_Wireless_CC3000_SocketGetInetAddr(TestIP_Addr, TestPort, &localSockAddr);

 BufNum = GetBuffer();
 sprintf(BufNum,"Local socket IP: %d.%d.%d.%d\r\n",TestIP_Addr[0],TestIP_Addr[1],TestIP_Addr[2],TestIP_Addr[3]);
 UART1_PutQueue(BufNum);

 BufNum = GetBuffer();
 sprintf(BufNum,"Local socket Port: %d\r\n",TestPort[0]);
 UART1_PutQueue(BufNum);

 RetVal = Net_Wireless_CC3000_SocketGetInetAddr(TestIP_Addr, TestPort, &remoteSockAddr);

 BufNum = GetBuffer();
 sprintf(BufNum,"Remote socket IP: %d.%d.%d.%d\r\n",TestIP_Addr[0],TestIP_Addr[1],TestIP_Addr[2],TestIP_Addr[3]);
 UART1_PutQueue(BufNum);

 BufNum = GetBuffer();
 sprintf(BufNum,"Remote socket Port: %d\r\n",TestPort[0]);
 UART1_PutQueue(BufNum);
}
#line 174 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/CC3000.c"
void DispSSID(void) {
 char *BufNum;
 char Length;

 RetVal = Net_Wireless_CC3000_GetScanResult(0, &TestScan);

 if (TestScan.status ==  1 ) {
 BufNum = GetBuffer();
 sprintf(BufNum,"\nstatus: %d\r\n",TestScan.status);
 UART1_PutQueue(BufNum);

 BufNum = GetBuffer();
 sprintf(BufNum,"netIndex: %d\r\n",TestScan.netIndex);
 UART1_PutQueue(BufNum);

 BufNum = GetBuffer();
 sprintf(BufNum,"rssi: %d\r\n",TestScan.rssi);
 UART1_PutQueue(BufNum);

 BufNum = GetBuffer();
 sprintf(BufNum,"securityMode: %d\r\n",TestScan.securityMode);
 UART1_PutQueue(BufNum);

 BufNum = GetBuffer();
 sprintf(BufNum,"ssidNameLength: %d\r\n",TestScan.ssidNameLength);
 UART1_PutQueue(BufNum);

 BufNum = GetBuffer();
 UART1_PutQueue("ssidName: ");
 Length = TestScan.ssidNameLength;
 strncpy(BufNum,TestScan.ssidName,Length);
 strcat(BufNum,"\r\n");
 UART1_PutQueue(BufNum);

 BufNum = GetBuffer();
 sprintf(BufNum," bssid: %d:%d:%d:%d:%d:%d\r\n",TestScan.bssid[0],TestScan.bssid[0],TestScan.bssid[0],TestScan.bssid[0],TestScan.bssid[0],TestScan.bssid[0]);
 UART1_PutQueue(BufNum);
 } else {
 UART1_PutQueue("No more APs\r\n");
 }
}
#line 219 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/CC3000.c"
void DispNVMEM(void) {
 char *BufNum;

 RetVal = Net_Wireless_CC3000_NvmemRead( 6 , 16, 0, NVMEM);
 BufNum = GetBuffer();
 sprintf(BufNum,"MAC: %02X:%02X:%02X:%02X:%02X:%02X\r\n",NVMEM[0],NVMEM[1],NVMEM[2],NVMEM[3],NVMEM[4],NVMEM[5]);
 UART1_PutQueue(BufNum);

 RetVal = Net_Wireless_CC3000_NvmemRead( 8 , 64, 0, NVMEM);
 BufNum = GetBuffer();
 sprintf(BufNum,"IP: %d.%d.%d.%d\r\n",NVMEM[0],NVMEM[1],NVMEM[2],NVMEM[3]);
 UART1_PutQueue(BufNum);

 BufNum = GetBuffer();
 sprintf(BufNum,"IP: %d.%d.%d.%d\r\n",NVMEM[4],NVMEM[5],NVMEM[6],NVMEM[7]);
 UART1_PutQueue(BufNum);

 RetVal = Net_Wireless_CC3000_NvmemRead( 12 , 16, 0, NVMEM);
 BufNum = GetBuffer();
 sprintf(BufNum,"AES128 key: %02X %02X %02X %02X %02X %02X %02X %02X\r\n",NVMEM[0],NVMEM[1],NVMEM[2],NVMEM[3],NVMEM[4],NVMEM[5],NVMEM[6],NVMEM[7]);
 UART1_PutQueue(BufNum);

 BufNum = GetBuffer();
 sprintf(BufNum,"AES128 key: %02X %02X %02X %02X %02X %02X %02X %02X\r\n",NVMEM[8],NVMEM[9],NVMEM[10],NVMEM[11],NVMEM[12],NVMEM[13],NVMEM[14],NVMEM[15]);
 UART1_PutQueue(BufNum);
}
#line 249 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/CC3000.c"
void DispVer(void) {
 char *BufNum;
 char Ver[2];

 BufNum = GetBuffer();
 if (Net_Wireless_CC3000_NvmemReadSpVer(&Ver) == 0)
 sprintf(BufNum,"Version: %d.%d\r\n",Ver[0],Ver[1]);
 else
 strcpy(BufNum,"Error\r\n");

 UART1_PutQueue(BufNum);
}







void SSI1_Interrupt() iv IVT_INT_SSI1 ics ICS_AUTO {
 SSI_ICR_EOTIC_SSI1_ICR_bit = 1;
 LED_Set_Green();
}
#line 276 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/CC3000.c"
void SPI1_Initialize(void) {
 SPI1_Init_Advanced(15000000, _SPI_MASTER, _SPI_8_BIT | _SPI_CLK_IDLE_LOW | _SPI_SECOND_CLK_EDGE_TRANSITION, &_GPIO_MODULE_SPI1_B5E45_AHB);
#line 308 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/CC3000.c"
}
#line 317 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/CC3000.c"
void GPIOInterrupt() iv IVT_INT_GPIOB ics ICS_AUTO {
 Net_Wireless_CC3000_IntGpioHandler();
}
#line 325 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/CC3000.c"
void Timer0A_interrupt() iv IVT_INT_TIMER0A_16_32_bit {
 TIMER_ICR_TATOCINT_bit = 1;
 timeOutCnt++;
 Net_Wireless_CC3000_Time++;
}
#line 335 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/CC3000.c"
void InitTimer0A(void) {
 SYSCTL_RCGCTIMER_R0_bit = 1;
 EnableInterrupts();
 TIMER_CTL_TAEN_bit = 0;
 TIMER0_CFG = 4;
 TIMER0_TAPR = 1;
 TIMER0_TAMR |= 2;
 TIMER0_TAILR = 60000;
 NVIC_IntEnable(IVT_INT_TIMER0A_16_32_bit);
 TIMER_IMR_TATOIM_bit = 1;
 TIMER_CTL_TAEN_bit = 1;
}
#line 351 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/CC3000.c"
int32_t Net_Wireless_CC3000_WaitHandler() {

 if(Net_Wireless_CC3000_Time > 30000) {
 return -1;
 }
 return 0;
}
#line 362 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/CC3000.c"
void WiFi_Polling(void) {
 int32_t status;

 Net_Wireless_CC3000_unsolEventHandler();

 status = Net_Wireless_CC3000_StatusGet();
 if (status ==  0 ) {
 Net_Wireless_CC3000_DiconnectFromAP();
 connectedFlag = 0;
 dhcpCompleteFlag = 0;
 UART1_PutQueue("CC3000 polling stopped\r\n");
 }

}
#line 382 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/CC3000.c"
void Net_Wireless_CC3000_UsynchCallback(int32_t eventType, uint8_t *dat, uint8_t length) {
 char *BufNum;



 BufNum = GetBuffer();
 sprintf(BufNum,"Event type: %04X  Length: %d\r\n",eventType,length);
 UART1_PutQueue(BufNum);

 switch (eventType) {

 case  0x8001 :
 connectedFlag = 1;

  UART1_PutQueue("_NET_WIRELESS_CC3000_EVNT_UNSOL_CONNECT\r\n") ;
 break;

 case  0x8002 :
 connectedFlag = 0;
 dhcpCompleteFlag = 0;

  UART1_PutQueue("_NET_WIRELESS_CC3000_EVNT_UNSOL_DISCONNECT\r\n") ;
 break;

 case  0x8004 :

  UART1_PutQueue("_NET_WIRELESS_CC3000_EVNT_UNSOL_INIT\r\n") ;
 break;

 case  0x8008 :

  UART1_PutQueue("_NET_WIRELESS_CC3000_EVNT_TX_COMPLETE\r\n") ;
 break;

 case  0x8010 :
#line 426 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/CC3000.c"
 dhcpCompleteFlag = 1;

  UART1_PutQueue("_NET_WIRELESS_CC3000_EVNT_UNSOL_DHCP\r\n") ;
 break;

 case  0x8040 :

  UART1_PutQueue("_NET_WIRELESS_CC3000_EVNT_ASYNC_PING\r\n") ;
 break;

 case  0x8080 :

  UART1_PutQueue("_NET_WIRELESS_CC3000_EVNT_ASYNC_SIMPLE_CFG_DONE\r\n") ;
 break;

 case  0x8200 :

  UART1_PutQueue("_NET_WIRELESS_CC3000_EVNT_KEEPALIVE\r\n") ;
 break;

 case  0x8800 :
 if (dat[0] == clientSock) {
 finReceive = 1;
 }

  UART1_PutQueue("_NET_WIRELESS_CC3000_EVNT_BSD_TCP_CLOSE_WAIT\r\n") ;
 break;

 case  0x0099 :

  UART1_PutQueue("_NET_WIRELESS_CC3000_EVENT_CAN_SHUT_DOWN\r\n") ;
 break;
 }
}
#line 465 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/CC3000.c"
void WiFi_StateMachine(void) {
 uint32_t timeOutDHCP = 14400;
 uint32_t timeOutARP = 3600;
 uint32_t timeOutKeepalive = 20;
 uint32_t timeOutInactivity = 20;
 char *BufNum;



 switch (State) {

 case 0:

 break;




 case 1:

  UART1_PutQueue("Initializing WiFi timer\r\n") ;
 InitTimer0A();
 State = 2;
 break;

 case 2:
 UART1_PutQueue("CC3000 configuring\r\n");

 SPI1_Initialize();

 (void) Net_Wireless_CC3000_Init();
 (void) Net_Wireless_CC3000_regAsynHandler(Net_Wireless_CC3000_UsynchCallback);
 NVIC_IntEnable(IVT_INT_GPIOB);

 UART1_PutQueue("CC3000 starting\r\n");
 (void) Net_Wireless_CC3000_Start(0);
 State = 3;
 break;

 case 3:
 RetVal = Net_Wireless_CC3000_SetMacAddr(myMacAddr);
 if (RetVal < 0) {
 UART1_PutQueue("Set MAC address error\r\n");
 State = 0;
 } else {
 UART1_PutQueue("CC3000 MAC address set\r\n");
 State = 4;
 }
 break;

 case 4:
 RetVal = Net_Wireless_CC3000_SetIpAddr(myIpAddr, ipMask, gwIpAddr, dnsIpAddr);
 if (RetVal < 0) {
 UART1_PutQueue("Set IP address error\r\n");
 State = 0;
 } else {
 UART1_PutQueue("CC3000 IP addresses set to 0 for DHCP\r\n");
 State = 5;
 }
 break;

 case 5:
 RetVal = Net_Wireless_CC3000_SetConnectPolicy(0,0,0);
 if (RetVal < 0){
 UART1_PutQueue("Set connect policy error\r\n");
 State = 0;
 } else {
 UART1_PutQueue("CC3000 connect policy set\r\n");
 State = 6;
 }
 break;

 case 6:
 RetVal = Net_Wireless_CC3000_SetTimeoutParams(&timeOutDHCP, &timeOutARP, &timeOutKeepalive, &timeOutInactivity);
 if (RetVal < 0){
 UART1_PutQueue("Set timeout parameters error\r\n");
 State = 0;
 } else {
 UART1_PutQueue("CC3000 timeout parameters set\r\n");
 State = 7;
 }
 break;

 case 7:
 RetVal = Net_Wireless_CC3000_DiconnectFromAP();
 UART1_PutQueue("CC3000 disconnected from AP\r\n");
 State = 8;
 break;

 case 8:
 (void) Net_Wireless_CC3000_Stop();
 (void) Net_Wireless_CC3000_Start(0);
 UART1_PutQueue("\nCC3000 restarting\r\n");
 InitTimer0A();
 finReceive = 0;
 UART1_PutQueue("CC3000 connecting to AP. Please wait...\r\n");
 State = 9;
 break;

 case 9:
 if (TxIn != TxOut) {
 State = 9;
 } else {
 State = 10;
 }
 break;

 case 10:
 RetVal = Net_Wireless_CC3000_ConnectToAP( 3 , ssid, strlen(ssid), 0, key, strlen(key));




 if (RetVal < 0){
 UART1_PutQueue("Connect to AP error\r\n");
 State = 0;
 } else {
 UART1_PutQueue("CC3000 connected to AP\r\n");
 State = 11;
 }
 break;

 case 11:
 if (connectedFlag != 1) {
 State = 11;
 } else {

 State = 12;
 }
 break;

 case 12:
 if (dhcpCompleteFlag != 1) {
 State = 12;
 } else {


 State = 13;
 }
 break;




 case 13:
 clientSock = Net_Wireless_CC3000_SocketCreate( 2 ,  1 ,
  6 );

 if(clientSock ==  -1 )
 {
 UART1_PutQueue("Socket error\r\n");
 State = 0;
 } else {

 UART1_PutQueue("Got socket OK\r\n");
 BufNum = GetBuffer();
 sprintf(BufNum,"Socket: %d\r\n",clientSock);
 UART1_PutQueue(BufNum);

 State = 14;
 }
 break;

 case 14:
 sockOptValue = 100;
 RetVal = Net_Wireless_CC3000_SocketSetOptions(clientSock,  0xffff ,
  1 , &sockOptValue, sizeof(sockOptValue));
 if (RetVal < 0) {
 UART1_PutQueue("Set socket options error 1\r\n");
 State = 0;
 } else {

  UART1_PutQueue("Set receive timeout OK\r\n") ;
 State = 15;
 }
 break;

 case 15:
 sockOptValue =  1 ;
 RetVal = Net_Wireless_CC3000_SocketSetOptions(clientSock,  0xffff ,
  0 , &sockOptValue, sizeof(sockOptValue));
 if (RetVal < 0) {
 UART1_PutQueue("Set socket options error 2\r\n");
 State = 0;
 } else {

  UART1_PutQueue("Set receive blocking OK\r\n") ;
 State = 16;
 }
 break;

 case 16:
 (void) Net_Wireless_CC3000_SocketSetInetAddr(0, localPort, &localSockAddr);

  UART1_PutQueue("Local socket structure set\r\n") ;
 State = 17;
 break;

 case 17:
 RetVal = Net_Wireless_CC3000_SocketBind(clientSock, &localSockAddr, sizeof(localSockAddr));
 if (RetVal < 0) {
 UART1_PutQueue("Socket bind error 1\r\n");
 State = 0;
 } else {

  UART1_PutQueue("Socket bind OK\r\n") ;
 State = 18;
 }
 break;

 case 18:

  UART1_PutQueue("Getting host IP address by DNS\r\n") ;
 RetVal = Net_Wireless_CC3000_SocketGetHostByName(timeServer, strlen(timeServer), timeServIpAddr);
 if (RetVal < 0) {
 UART1_PutQueue("Get host by name error\r\n");
 State = 0;
 } else {

  UART1_PutQueue("Got host IP address\r\n") ;
 State = 19;
 }
 break;

 case 19:
 remoteIpAddr[0] = (timeServIpAddr[0]);
 remoteIpAddr[1] = (timeServIpAddr[0] >> 8);
 remoteIpAddr[2] = (timeServIpAddr[0] >> 16);
 remoteIpAddr[3] = (timeServIpAddr[0] >> 24);

 BufNum = GetBuffer();
 sprintf(BufNum,"Remote IP address: %d.%d.%d.%d\r\n",remoteIpAddr[0],remoteIpAddr[1],remoteIpAddr[2],remoteIpAddr[3]);
 UART1_PutQueue(BufNum);

 State = 20;
 break;

 case 20:
 (void) Net_Wireless_CC3000_SocketSetInetAddr(remoteIpAddr, remotePort, &remoteSockAddr);

  UART1_PutQueue("Remote socket structure set\r\n") ;

 DispSocket();

 State = 21;
 break;

 case 21:
 RetVal = Net_Wireless_CC3000_SocketConnect(clientSock, &remoteSockAddr, sizeof(remoteSockAddr));
 Counter = 0;
 State = 22;
 break;

 case 22:
 if (RetVal != 0) {
 Counter += 1;
 State = 22;
 } else {

 BufNum = GetBuffer();
 sprintf(BufNum,"Counter: %d\r\n",Counter);
 UART1_PutQueue(BufNum);

 State = 23;
 }
 break;

 case 23:
 LED_Set_Green();
 numOfRcvBytes = 0;
 numOfRcvBytes = Net_Wireless_CC3000_SocketReceive(clientSock, dataBuff,  1400 , 0);

 if (numOfRcvBytes <= 0) {
 UART1_PutQueue("No data received\r\n");
 State = 27;
 } else {

  UART1_PutQueue("Data received from server\r\n") ;
 State = 24;
 }
 break;

 case 24:
 LED_Clr_Green();

 BufNum = GetBuffer();
 sprintf(BufNum,"Bytes received: %d\r\n",numOfRcvBytes);
 UART1_PutQueue(BufNum);

 State = 25;
 break;

 case 25:
  ((char *)&epoch)[3]  = dataBuff[0];
  ((char *)&epoch)[2]  = dataBuff[1];
  ((char *)&epoch)[1]  = dataBuff[2];
  ((char *)&epoch)[0]  = dataBuff[3];

 epoch = epoch - 2208988800 - 14400;
 (void) Time_epochToDate(epoch, &my_time);

  UART1_PutQueue("Obtained time\r\n") ;
 State = 26;
 break;

 case 26:

 BufNum = GetBuffer();
 sprintf(BufNum,"Time: %d/%02d/%02d %02d:%02d:%02d\r\n",my_time.yy,my_time.mo,my_time.md,my_time.hh,my_time.mn,my_time.ss);
 UART1_PutQueue(BufNum);

 ObtainedTime =  1 ;
 State = 27;
 break;

 case 27:

 State = 28;
 break;

 case 28:
 RetVal = Net_Wireless_CC3000_SocketClose(clientSock);
 if (RetVal < 0) {
 UART1_PutQueue("Socket close error 1\r\n");
 } else {

  UART1_PutQueue("Socket closed OK\r\n") ;
 }
 State = 29;
 break;

 case 29:
 RetVal = Net_Wireless_CC3000_DiconnectFromAP();

  UART1_PutQueue("CC3000 disconnected from AP\r\n") ;
 State = 32;
 break;

 case 30:

 break;

 case 31:

 break;

 case 32:
 (void) Net_Wireless_CC3000_Stop();
 UART1_PutQueue("CC3000 reset\r\n");
 State = 0;
 break;



 case 33:
 UART1_PutQueue("Initializing WiFi timer\r\n");
 InitTimer0A();
 State = 34;
 break;

 case 34:
 UART1_PutQueue("CC3000 configuring\r\n");

 SPI1_Initialize();
 (void) Net_Wireless_CC3000_Init();
 (void) Net_Wireless_CC3000_regAsynHandler(Net_Wireless_CC3000_UsynchCallback);
 NVIC_IntEnable(IVT_INT_GPIOB);

 UART1_PutQueue("CC3000 starting\r\n");
 (void) Net_Wireless_CC3000_Start(0);
 State = 35;
 break;

 case 35:
 WiFiTimer = get_timer();
 set_timer(WiFiTimer,2000);
 RetVal = Net_Wireless_CC3000_SetScanParams(1, 100, 200, 5, 0x1fff, -75, 0, 205, 0);
 State = 36;
 break;

 case 36:
 if (check_timer(WiFiTimer) == 0) {
 State = 37;
 }
 break;

 case 37:
 DispSSID();
 if (TestScan.status ==  1 ) {
 set_timer(WiFiTimer,2000);
 State = 36;
 } else {
 free_timer(WiFiTimer);
 State = 32;
 }
 break;



 case 38:
 UART1_PutQueue("Initializing WiFi timer\r\n");
 InitTimer0A();
 State = 39;
 break;

 case 39:
 UART1_PutQueue("CC3000 configuring\r\n");

 SPI1_Initialize();
 (void) Net_Wireless_CC3000_Init();
 (void) Net_Wireless_CC3000_regAsynHandler(Net_Wireless_CC3000_UsynchCallback);
 NVIC_IntEnable(IVT_INT_GPIOB);

 UART1_PutQueue("CC3000 starting\r\n");
 (void) Net_Wireless_CC3000_Start(0);
 State = 40;
 break;

 case 40:
 WiFiTimer = get_timer();
 set_timer(WiFiTimer,500);
 State = 41;
 break;

 case 41:
 if (check_timer(WiFiTimer) == 0) {
 State = 42;
 }
 break;

 case 42:
 DispNVMEM();
 DispVer();
 DispSocket();
 State = 32;
 break;



 }
}
