/**************************************************************************************************
  CC3000.h
  Driver for Wi-Fi chip.
**************************************************************************************************/
#ifndef CC3000_H
#define CC3000_H



#include "stdint.h"



// Defines





// Function Prototypes
void DispDHCP(void);      // Diagnostic
void DispSocket(void);    // Diagnostic
void DispSSID(void);      // Diagnostic
void DispVer(void);       // Diagnostic

void SPI1_Initialize(void);




void InitTimer0A(void);
int32_t Net_Wireless_CC3000_WaitHandler();
void WiFi_Polling(void);
void Net_Wireless_CC3000_UsynchCallback(int32_t eventType, uint8_t *dat, uint8_t length);

void WiFi_StateMachine(void);


#endif