#line 1 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/RTCC.c"
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/rtcc.h"
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/__time.h"
#line 30 "c:/arm projects/mikromedia 5 for tiva/wifi/__time.h"
typedef struct
{
 unsigned char ss;
 unsigned char mn;
 unsigned char hh;
 unsigned char md;
 unsigned char wd;
 unsigned char mo;
 unsigned int yy;
} TimeStruct ;
#line 44 "c:/arm projects/mikromedia 5 for tiva/wifi/__time.h"
extern long Time_jd1970;
#line 49 "c:/arm projects/mikromedia 5 for tiva/wifi/__time.h"
long Time_dateToEpoch(TimeStruct *ts);
long Time_dateDiff(TimeStruct *t1, TimeStruct *t2);
void Time_epochToDate(long e, TimeStruct *ts);
#line 28 "c:/arm projects/mikromedia 5 for tiva/wifi/rtcc.h"
void HibernateRTCDisable(void);
void HibernateRTCEnable(void);
void HibernateRTCSet(TimeStruct *temp);
unsigned long HibernateRTCGet(TimeStruct *temp);

char DayOfWeek(unsigned yr, char mo, char dy);
void RTC_Init(void);
void Set_RTC(TimeStruct *DateTime);
char RTCC_Read(TimeStruct *DateTime);

void RTC_Initialize(void);
void RTC_StateMachine(void);
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/built_in.h"
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/__time.h"
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/buffers.h"
#line 13 "c:/arm projects/mikromedia 5 for tiva/wifi/buffers.h"
char* GetBuffer(void);
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/uart1.h"
#line 21 "c:/arm projects/mikromedia 5 for tiva/wifi/uart1.h"
typedef void (* tPointerFcn)(void);



void UART1_Enable(void);
void UART1_StartRx(void);
void UART1_StartTx(void);
char UART1_CheckFree(void);

void UART1_Initialize(void);
void UART1_RxQueueInit(void);
char UART1_GetChar(char *rxbyte);
void UART1_Rx(void);
void UART1_Rx1(void);
void UART1_Rx2(void);

void UART1_TxQueueInit(void);
void UART1_PutQueue(char *msg);
void UART1_SendMsg(char *s);
void UART1_Tx(void);
void UART1_Tx1(void);
void UART1_Send(char *s);
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/common.h"
#line 23 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/RTCC.c"
unsigned long RTC_Time, old_RTC_Time;
unsigned long RTC_Date, old_RTC_Date;

unsigned short RTC_Timer;
unsigned char RTC_State = 0;
#line 38 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/RTCC.c"
void Hibernate_Interrupt() iv IVT_INT_HIBERNATE ics ICS_AUTO {
 HIB_IC_RTCALT0_bit = 1;
}
#line 45 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/RTCC.c"
void HibernateRTCDisable(void) {
 while(!HIB_CTL_WRC_bit);
 HIB_CTL_RTCEN_bit = 0;


}
#line 61 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/RTCC.c"
void HibernateRTCEnable(void) {



 while(!HIB_CTL_WRC_bit);

 HIB_CTL_CLK32EN_bit = 1;
 Delay_ms(1000);

 while(!HIB_CTL_WRC_bit);
 HIB_RTCM0 = 86400;

 while(!HIB_CTL_WRC_bit);

 HIB_IM_RTCALT0_bit = 1;

 while(!HIB_CTL_WRC_bit);

 HIB_CTL_RTCEN_bit = 1;
}
#line 90 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/RTCC.c"
void HibernateRTCSet(TimeStruct *temp) {
 unsigned long tmptmp = 0;
 char *BufNum;


 tmptmp = (unsigned long)temp->hh*3600;
 tmptmp += (unsigned long)temp->mn*60;
 tmptmp += (unsigned long)temp->ss;

 while(!HIB_CTL_WRC_bit);
 HIB_RTCLD = tmptmp;
#line 109 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/RTCC.c"
}
#line 119 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/RTCC.c"
unsigned long HibernateRTCGet(TimeStruct *temp) {
 unsigned long clk;
 char *BufNum;

 clk = HIB_RTCC;
 temp->hh = clk%86400/3600;
 temp->mn = clk%3600/60;
 temp->ss = clk%60;
#line 132 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/RTCC.c"
 return clk;
}
#line 146 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/RTCC.c"
void RTC_Init(void) {
 TimeStruct My_Time;

 My_Time.ss = 12;
 My_Time.mn = 43;
 My_Time.hh = 22;
 My_Time.md = 07;
 My_Time.mo = 4;
 My_Time.yy = 2014;

 HibernateRTCEnable();
 HibernateRTCSet(&My_Time);
}
#line 168 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/RTCC.c"
void Set_RTC(TimeStruct *DateTime) {
 TimeStruct My_Time;

 My_Time.ss = DateTime->ss;
 My_Time.mn = DateTime->mn;
 My_Time.hh = DateTime->hh;

 My_Time.md = DateTime->md;
 My_Time.mo = DateTime->mo;
 My_Time.yy = DateTime->yy;

 HibernateRTCSet(&My_Time);
}
#line 190 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/RTCC.c"
char RTCC_Read(TimeStruct *DateTime) {
 char temp = 0;
 TimeStruct My_Time;

 My_Time.yy = 0;
 My_Time.mo = 0;
 My_Time.md = 0;

 RTC_Time = HibernateRTCGet(&My_Time);

 if (RTC_Time != Old_RTC_Time) {
 DateTime->ss = My_Time.ss;
 DateTime->mn = My_Time.mn;
 DateTime->hh = My_Time.hh;

 DateTime->md = My_Time.md;
 DateTime->mo = My_Time.mo;
 DateTime->yy = My_Time.yy;

 Old_RTC_Time = RTC_Time;
 temp = 1;
 }
 return temp;
}
#line 232 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/RTCC.c"
unsigned long TimeLoad;
unsigned long DateLoad;
unsigned long TimeRead;
unsigned long DateRead;
unsigned Yr;
char Mo;
char Da;
char Hr;
char Mn;
char Se;
char DoW;

extern unsigned char ObtainedTime;
extern unsigned char State;
extern TimeStruct my_time;
#line 255 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/RTCC.c"
char DayOfWeek(unsigned yr, char mo, char dy) {
 int dow;

 if (mo < 3) {
 mo += 12;
 --yr;
 }


 dow = dy + (13 * mo - 27) / 5 + yr + yr/4 - yr/100 + yr/400;
 while (dow < 0) dow += 7;
 dow %= 7;
 return (char)dow;
}
#line 273 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/RTCC.c"
void RTC_Initialize(void) {
 HIB_CTL_CLK32EN_bit = 1;
}
#line 280 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/RTCC.c"
void RTC_StateMachine(void) {
 char *BufNum;


 switch (RTC_State) {

 case 0:
 break;




 case 1:
 if (HIB_CTL_WRC_bit)
 RTC_State = 2;
 break;

 case 2:
 HIB_CALCTL_CALEN_bit =1;
 RTC_State = 3;
 break;

 case 3:
 if (HIB_CTL_WRC_bit)
 RTC_State = 4;
 break;

 case 4:
 HIB_CALCTL_CAL24_bit =1;
 RTC_State = 5;
 break;

 case 5:
 if (HIB_CTL_WRC_bit)
 RTC_State = 6;
 break;

 case 6:
 HIB_CTL_RTCEN_bit = 0;
 RTC_State = 7;
 break;

 case 7:
 State = 1;
 RTC_State = 8;
 break;

 case 8:
 if (State != 0 && ObtainedTime !=  1 ) {
 RTC_State = 8;
 } else {
 if (ObtainedTime ==  1 ) {
 TimeLoad = 0;
 DateLoad = 0;
 RTC_State = 9;
 } else {
 UART1_PutQueue("Couldn't obtain time. Aborting...\r\n");
 RTC_State = 0;
 }
 }
 break;

 case 9:
 TimeLoad = (my_time.hh&0x1F);
 TimeLoad = (TimeLoad<<8);

 TimeLoad |= (my_time.mn&0x3F);
 TimeLoad = (TimeLoad<<8);

 TimeLoad |= (my_time.ss&0x3F);


 UART1_PutQueue("Time load value: ");
 BufNum = GetBuffer();
 LongWordToHex(TimeLoad, BufNum);
 strcat(BufNum,"\r\n");
 UART1_PutQueue(BufNum);


 DoW = DayOfWeek(((my_time.yy-2000)&0x7F), (my_time.mo&0x0F), (my_time.md&0x1F));

 DateLoad = DoW;
 DateLoad = (DateLoad<<8);

 DateLoad |= ((my_time.yy-2000)&0x7F);
 DateLoad = (DateLoad<<8);


 BufNum = GetBuffer();
 sprintf(BufNum,"Year is: %d\r\n",my_time.yy);
 UART1_PutQueue(BufNum);

 DateLoad |= (my_time.mo&0x0F);
 DateLoad = (DateLoad<<8);

 DateLoad |= (my_time.md&0x1F);


 UART1_PutQueue("Date load value: ");
 BufNum = GetBuffer();
 LongWordToHex(DateLoad, BufNum);
 strcat(BufNum,"\r\n");
 UART1_PutQueue(BufNum);

 RTC_State = 10;
 break;

 case 10:
 if (HIB_CTL_WRC_bit)
 RTC_State = 11;
 break;

 case 11:
 HIB_CALLD0 = TimeLoad;
 RTC_State = 12;
 break;

 case 12:
 if (HIB_CTL_WRC_bit)
 RTC_State = 13;
 break;

 case 13:
 HIB_CALLD1 = DateLoad;
 RTC_State = 14;
 break;

 case 14:
 if (HIB_CTL_WRC_bit)
 RTC_State = 15;
 break;

 case 15:
 HIB_CTL_RTCEN_bit = 1;
 UART1_PutQueue("RTC set\r\n");
 RTC_State = 0;
 break;




 case 16:
 TimeRead = HIB_CAL0;
 DateRead = HIB_CAL1;

 UART1_PutQueue("Time read: ");
 BufNum = GetBuffer();
 LongWordToHex(TimeRead, BufNum);
 strcat(BufNum,"\r\n");
 UART1_PutQueue(BufNum);

 UART1_PutQueue("Date read: ");
 BufNum = GetBuffer();
 LongWordToHex(DateRead, BufNum);
 strcat(BufNum,"\r\n");
 UART1_PutQueue(BufNum);

 RTC_State = 17;
 break;

 case 17:
 Yr = (char)(DateRead >> 16);
 Yr += 2000;
 Mo = DateRead >> 8;
 Da = DateRead;

 Hr = TimeRead >> 16;
 Mn = TimeRead >> 8;
 Se = TimeRead;

 BufNum = GetBuffer();
 sprintf(BufNum,"Date: %d/%d/%d  Time: %d:%02d:%02d\r\n",Yr,Mo,Da,Hr,Mn,Se);
 UART1_PutQueue(BufNum);
 RTC_State = 0;

 DoW = DayOfWeek(Yr, Mo, Da);

 BufNum = GetBuffer();
 sprintf(BufNum,"DoW: %d\r\n",DoW);
 UART1_PutQueue(BufNum);

 RTC_State = 0;
 break;




 case 18:
 if (HIB_CTL_WRC_bit)
 RTC_State = 19;
 break;

 case 19:
 HIB_CALCTL_CALEN_bit =1;
 RTC_State = 20;
 break;

 case 20:
 if (HIB_CTL_WRC_bit)
 RTC_State = 21;
 break;

 case 21:
 HIB_CALCTL_CAL24_bit =1;
 RTC_State = 22;
 break;

 case 22:
 if (HIB_CTL_WRC_bit)
 RTC_State = 23;
 break;

 case 23:
 HIB_CTL_RTCEN_bit = 0;
 RTC_State = 24;
 break;

 case 24:
 if (HIB_CTL_WRC_bit)
 RTC_State = 25;
 break;

 case 25:
 HIB_CALLD0 = 0x000D091C;
 RTC_State = 26;
 break;

 case 26:
 if (HIB_CTL_WRC_bit)
 RTC_State = 27;
 break;

 case 27:
 HIB_CALLD1 = 0x000F0405;
 RTC_State = 28;
 break;

 case 28:
 UART1_PutQueue("Test complete\r\n");
 RTC_State = 0;
 break;

 }
}
