#line 1 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/WiFi.c"
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/led.h"
#line 13 "c:/arm projects/mikromedia 5 for tiva/wifi/led.h"
void LED_Initialize(void);

void LED_Set_Red(void);
void LED_Clr_Red(void);
void LED_Set_Green(void);
void LED_Clr_Green(void);
void LED_Set_Blue(void);
void LED_Clr_Blue(void);
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/uart1.h"
#line 21 "c:/arm projects/mikromedia 5 for tiva/wifi/uart1.h"
typedef void (* tPointerFcn)(void);



void UART1_Enable(void);
void UART1_StartRx(void);
void UART1_StartTx(void);
char UART1_CheckFree(void);

void UART1_Initialize(void);
void UART1_RxQueueInit(void);
char UART1_GetChar(char *rxbyte);
void UART1_Rx(void);
void UART1_Rx1(void);
void UART1_Rx2(void);

void UART1_TxQueueInit(void);
void UART1_PutQueue(char *msg);
void UART1_SendMsg(char *s);
void UART1_Tx(void);
void UART1_Tx1(void);
void UART1_Send(char *s);
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/cc3000.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 21 "c:/arm projects/mikromedia 5 for tiva/wifi/cc3000.h"
void DispDHCP(void);
void DispSocket(void);
void DispSSID(void);
void DispVer(void);

void SPI1_Initialize(void);




void InitTimer0A(void);
int32_t Net_Wireless_CC3000_WaitHandler();
void WiFi_Polling(void);
void Net_Wireless_CC3000_UsynchCallback(int32_t eventType, uint8_t *dat, uint8_t length);

void WiFi_StateMachine(void);
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
#line 11 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
void TimerInit(void);
void TimerCheck(void);
#line 33 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
struct timers {
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 45 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
void init_timerpool(void);
#line 54 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
unsigned short int get_timer(void);
#line 64 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 73 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
unsigned long int check_timer(unsigned short int nbr);
#line 82 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
void free_timer(unsigned short int nbr);
#line 91 "c:/arm projects/mikromedia 5 for tiva/wifi/timers.h"
void irqhandler_timer(void);
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/rtcc.h"
#line 1 "c:/arm projects/mikromedia 5 for tiva/wifi/__time.h"
#line 30 "c:/arm projects/mikromedia 5 for tiva/wifi/__time.h"
typedef struct
{
 unsigned char ss;
 unsigned char mn;
 unsigned char hh;
 unsigned char md;
 unsigned char wd;
 unsigned char mo;
 unsigned int yy;
} TimeStruct ;
#line 44 "c:/arm projects/mikromedia 5 for tiva/wifi/__time.h"
extern long Time_jd1970;
#line 49 "c:/arm projects/mikromedia 5 for tiva/wifi/__time.h"
long Time_dateToEpoch(TimeStruct *ts);
long Time_dateDiff(TimeStruct *t1, TimeStruct *t2);
void Time_epochToDate(long e, TimeStruct *ts);
#line 28 "c:/arm projects/mikromedia 5 for tiva/wifi/rtcc.h"
void HibernateRTCDisable(void);
void HibernateRTCEnable(void);
void HibernateRTCSet(TimeStruct *temp);
unsigned long HibernateRTCGet(TimeStruct *temp);

char DayOfWeek(unsigned yr, char mo, char dy);
void RTC_Init(void);
void Set_RTC(TimeStruct *DateTime);
char RTCC_Read(TimeStruct *DateTime);

void RTC_Initialize(void);
void RTC_StateMachine(void);
#line 44 "C:/ARM Projects/Mikromedia 5 for Tiva/WiFi/WiFi.c"
extern uint32_t connectedFlag, dhcpCompleteFlag;





void main() {

 TimerInit();

 RTC_Initialize();
 LED_Initialize();

 UART1_Initialize();
 UART1_PutQueue("Started CC3000 test program\r\n");


 EnableInterrupts();

 while (1) {
 UART1_Rx();
 UART1_Tx();
 TimerCheck();


 if ((connectedFlag == 1) || (dhcpCompleteFlag == 1))
 WiFi_Polling();

 WiFi_StateMachine();
 RTC_StateMachine();
 }
}
