_Hibernate_Interrupt:
;RTCC.c,38 :: 		void Hibernate_Interrupt() iv IVT_INT_HIBERNATE ics ICS_AUTO {
;RTCC.c,39 :: 		HIB_IC_RTCALT0_bit = 1;  // Clear RTCALT0 interrupt
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(HIB_IC_RTCALT0_bit+0)
MOVT	R0, #hi_addr(HIB_IC_RTCALT0_bit+0)
STR	R1, [R0, #0]
;RTCC.c,40 :: 		}
L_end_Hibernate_Interrupt:
BX	LR
; end of _Hibernate_Interrupt
_HibernateRTCDisable:
;RTCC.c,45 :: 		void HibernateRTCDisable(void) {
;RTCC.c,46 :: 		while(!HIB_CTL_WRC_bit);
L_HibernateRTCDisable0:
MOVW	R1, #lo_addr(HIB_CTL_WRC_bit+0)
MOVT	R1, #hi_addr(HIB_CTL_WRC_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	NE
BNE	L_HibernateRTCDisable1
IT	AL
BAL	L_HibernateRTCDisable0
L_HibernateRTCDisable1:
;RTCC.c,47 :: 		HIB_CTL_RTCEN_bit = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(HIB_CTL_RTCEN_bit+0)
MOVT	R0, #hi_addr(HIB_CTL_RTCEN_bit+0)
STR	R1, [R0, #0]
;RTCC.c,50 :: 		}
L_end_HibernateRTCDisable:
BX	LR
; end of _HibernateRTCDisable
_HibernateRTCEnable:
;RTCC.c,61 :: 		void HibernateRTCEnable(void) {
;RTCC.c,65 :: 		while(!HIB_CTL_WRC_bit);
L_HibernateRTCEnable2:
MOVW	R1, #lo_addr(HIB_CTL_WRC_bit+0)
MOVT	R1, #hi_addr(HIB_CTL_WRC_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	NE
BNE	L_HibernateRTCEnable3
IT	AL
BAL	L_HibernateRTCEnable2
L_HibernateRTCEnable3:
;RTCC.c,67 :: 		HIB_CTL_CLK32EN_bit = 1;     // Enable 32.768kHz oscillator
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(HIB_CTL_CLK32EN_bit+0)
MOVT	R0, #hi_addr(HIB_CTL_CLK32EN_bit+0)
STR	R1, [R0, #0]
;RTCC.c,68 :: 		Delay_ms(1000);
MOVW	R7, #23038
MOVT	R7, #610
NOP
NOP
L_HibernateRTCEnable4:
SUBS	R7, R7, #1
BNE	L_HibernateRTCEnable4
NOP
NOP
NOP
;RTCC.c,70 :: 		while(!HIB_CTL_WRC_bit);
L_HibernateRTCEnable6:
MOVW	R1, #lo_addr(HIB_CTL_WRC_bit+0)
MOVT	R1, #hi_addr(HIB_CTL_WRC_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	NE
BNE	L_HibernateRTCEnable7
IT	AL
BAL	L_HibernateRTCEnable6
L_HibernateRTCEnable7:
;RTCC.c,71 :: 		HIB_RTCM0 = 86400;           // Match with counter when 24 hours have elapsed
MOVW	R1, #20864
MOVT	R1, #1
MOVW	R0, #lo_addr(HIB_RTCM0+0)
MOVT	R0, #hi_addr(HIB_RTCM0+0)
STR	R1, [R0, #0]
;RTCC.c,73 :: 		while(!HIB_CTL_WRC_bit);
L_HibernateRTCEnable8:
MOVW	R1, #lo_addr(HIB_CTL_WRC_bit+0)
MOVT	R1, #hi_addr(HIB_CTL_WRC_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	NE
BNE	L_HibernateRTCEnable9
IT	AL
BAL	L_HibernateRTCEnable8
L_HibernateRTCEnable9:
;RTCC.c,75 :: 		HIB_IM_RTCALT0_bit = 1;      // Allow interrupts when HIBERTCM0 register matches HIBERTCC register
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(HIB_IM_RTCALT0_bit+0)
MOVT	R0, #hi_addr(HIB_IM_RTCALT0_bit+0)
STR	R1, [R0, #0]
;RTCC.c,77 :: 		while(!HIB_CTL_WRC_bit);
L_HibernateRTCEnable10:
MOVW	R1, #lo_addr(HIB_CTL_WRC_bit+0)
MOVT	R1, #hi_addr(HIB_CTL_WRC_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	NE
BNE	L_HibernateRTCEnable11
IT	AL
BAL	L_HibernateRTCEnable10
L_HibernateRTCEnable11:
;RTCC.c,79 :: 		HIB_CTL_RTCEN_bit = 1;        // Turn on counter
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(HIB_CTL_RTCEN_bit+0)
MOVT	R0, #hi_addr(HIB_CTL_RTCEN_bit+0)
STR	R1, [R0, #0]
;RTCC.c,80 :: 		}
L_end_HibernateRTCEnable:
BX	LR
; end of _HibernateRTCEnable
_HibernateRTCSet:
;RTCC.c,90 :: 		void HibernateRTCSet(TimeStruct *temp) {
; temp start address is: 0 (R0)
; temp end address is: 0 (R0)
; temp start address is: 0 (R0)
;RTCC.c,91 :: 		unsigned long tmptmp = 0;
;RTCC.c,95 :: 		tmptmp  = (unsigned long)temp->hh*3600;     // Convert hours to seconds
ADDS	R1, R0, #2
LDRB	R1, [R1, #0]
UXTB	R2, R1
MOVW	R1, #3600
MUL	R3, R2, R1
;RTCC.c,96 :: 		tmptmp += (unsigned long)temp->mn*60;       // Convert minutes to seconds and add to total
ADDS	R1, R0, #1
LDRB	R1, [R1, #0]
UXTB	R2, R1
MOVS	R1, #60
MULS	R1, R2, R1
ADDS	R2, R3, R1
;RTCC.c,97 :: 		tmptmp += (unsigned long)temp->ss;          // Add in seconds to total
LDRB	R1, [R0, #0]
; temp end address is: 0 (R0)
ADDS	R0, R2, R1
; tmptmp start address is: 0 (R0)
; tmptmp end address is: 0 (R0)
;RTCC.c,99 :: 		while(!HIB_CTL_WRC_bit);
L_HibernateRTCSet12:
; tmptmp start address is: 0 (R0)
MOVW	R2, #lo_addr(HIB_CTL_WRC_bit+0)
MOVT	R2, #hi_addr(HIB_CTL_WRC_bit+0)
LDR	R1, [R2, #0]
CMP	R1, #0
IT	NE
BNE	L_HibernateRTCSet13
IT	AL
BAL	L_HibernateRTCSet12
L_HibernateRTCSet13:
;RTCC.c,100 :: 		HIB_RTCLD = tmptmp;                         // Set RTC counter
MOVW	R1, #lo_addr(HIB_RTCLD+0)
MOVT	R1, #hi_addr(HIB_RTCLD+0)
STR	R0, [R1, #0]
; tmptmp end address is: 0 (R0)
;RTCC.c,109 :: 		}
L_end_HibernateRTCSet:
BX	LR
; end of _HibernateRTCSet
_HibernateRTCGet:
;RTCC.c,119 :: 		unsigned long HibernateRTCGet(TimeStruct *temp) {
; temp start address is: 0 (R0)
; temp end address is: 0 (R0)
; temp start address is: 0 (R0)
;RTCC.c,123 :: 		clk = HIB_RTCC;                   // Get RTC counter
MOVW	R1, #lo_addr(HIB_RTCC+0)
MOVT	R1, #hi_addr(HIB_RTCC+0)
; clk start address is: 16 (R4)
LDR	R4, [R1, #0]
;RTCC.c,124 :: 		temp->hh = clk%86400/3600;        // Extract hours and put in time structure
ADDS	R3, R0, #2
MOVW	R1, #20864
MOVT	R1, #1
UDIV	R2, R4, R1
MLS	R2, R1, R2, R4
MOVW	R1, #3600
UDIV	R1, R2, R1
STRB	R1, [R3, #0]
;RTCC.c,125 :: 		temp->mn = clk%3600/60;           // Extract minutes and put in time structure
ADDS	R3, R0, #1
MOVW	R1, #3600
UDIV	R2, R4, R1
MLS	R2, R1, R2, R4
MOVS	R1, #60
UDIV	R1, R2, R1
STRB	R1, [R3, #0]
;RTCC.c,126 :: 		temp->ss = clk%60;                // Extract seconds and put in time structure
MOVS	R2, #60
UDIV	R1, R4, R2
MLS	R1, R2, R1, R4
STRB	R1, [R0, #0]
; temp end address is: 0 (R0)
;RTCC.c,132 :: 		return clk;                             // Return current counter value
MOV	R0, R4
; clk end address is: 16 (R4)
;RTCC.c,133 :: 		}
L_end_HibernateRTCGet:
BX	LR
; end of _HibernateRTCGet
_RTC_Init:
;RTCC.c,146 :: 		void RTC_Init(void) {
SUB	SP, SP, #12
STR	LR, [SP, #0]
;RTCC.c,149 :: 		My_Time.ss = 12;
MOVS	R0, #12
STRB	R0, [SP, #4]
;RTCC.c,150 :: 		My_Time.mn = 43;
MOVS	R0, #43
STRB	R0, [SP, #5]
;RTCC.c,151 :: 		My_Time.hh = 22;
MOVS	R0, #22
STRB	R0, [SP, #6]
;RTCC.c,152 :: 		My_Time.md = 07;
MOVS	R0, #7
STRB	R0, [SP, #7]
;RTCC.c,153 :: 		My_Time.mo = 4;
MOVS	R0, #4
STRB	R0, [SP, #9]
;RTCC.c,154 :: 		My_Time.yy = 2014;
MOVW	R0, #2014
STRH	R0, [SP, #10]
;RTCC.c,156 :: 		HibernateRTCEnable();        // Go enable RTC
BL	_HibernateRTCEnable+0
;RTCC.c,157 :: 		HibernateRTCSet(&My_Time);
ADD	R0, SP, #4
BL	_HibernateRTCSet+0
;RTCC.c,158 :: 		}
L_end_RTC_Init:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _RTC_Init
_Set_RTC:
;RTCC.c,168 :: 		void Set_RTC(TimeStruct *DateTime) {
; DateTime start address is: 0 (R0)
SUB	SP, SP, #12
STR	LR, [SP, #0]
; DateTime end address is: 0 (R0)
; DateTime start address is: 0 (R0)
;RTCC.c,171 :: 		My_Time.ss = DateTime->ss;
LDRB	R1, [R0, #0]
STRB	R1, [SP, #4]
;RTCC.c,172 :: 		My_Time.mn = DateTime->mn;
ADDS	R1, R0, #1
LDRB	R1, [R1, #0]
STRB	R1, [SP, #5]
;RTCC.c,173 :: 		My_Time.hh = DateTime->hh;   // Assume a 24 hour clock
ADDS	R1, R0, #2
LDRB	R1, [R1, #0]
STRB	R1, [SP, #6]
;RTCC.c,175 :: 		My_Time.md = DateTime->md;
ADDS	R1, R0, #3
LDRB	R1, [R1, #0]
STRB	R1, [SP, #7]
;RTCC.c,176 :: 		My_Time.mo = DateTime->mo;
ADDS	R1, R0, #5
LDRB	R1, [R1, #0]
STRB	R1, [SP, #9]
;RTCC.c,177 :: 		My_Time.yy = DateTime->yy;
ADDS	R1, R0, #6
; DateTime end address is: 0 (R0)
LDRH	R1, [R1, #0]
STRH	R1, [SP, #10]
;RTCC.c,179 :: 		HibernateRTCSet(&My_Time);
ADD	R1, SP, #4
MOV	R0, R1
BL	_HibernateRTCSet+0
;RTCC.c,180 :: 		}
L_end_Set_RTC:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _Set_RTC
_RTCC_Read:
;RTCC.c,190 :: 		char RTCC_Read(TimeStruct *DateTime) {
; DateTime start address is: 0 (R0)
SUB	SP, SP, #12
STR	LR, [SP, #0]
MOV	R5, R0
; DateTime end address is: 0 (R0)
; DateTime start address is: 20 (R5)
;RTCC.c,191 :: 		char temp = 0;
; temp start address is: 24 (R6)
MOVS	R6, #0
;RTCC.c,194 :: 		My_Time.yy = 0;
MOVS	R1, #0
STRH	R1, [SP, #10]
;RTCC.c,195 :: 		My_Time.mo = 0;
MOVS	R1, #0
STRB	R1, [SP, #9]
;RTCC.c,196 :: 		My_Time.md = 0;
MOVS	R1, #0
STRB	R1, [SP, #7]
;RTCC.c,198 :: 		RTC_Time = HibernateRTCGet(&My_Time);
ADD	R1, SP, #4
MOV	R0, R1
BL	_HibernateRTCGet+0
MOVW	R1, #lo_addr(_RTC_Time+0)
MOVT	R1, #hi_addr(_RTC_Time+0)
STR	R0, [R1, #0]
;RTCC.c,200 :: 		if (RTC_Time != Old_RTC_Time) {
MOVW	R1, #lo_addr(_old_RTC_Time+0)
MOVT	R1, #hi_addr(_old_RTC_Time+0)
LDR	R1, [R1, #0]
CMP	R0, R1
IT	EQ
BEQ	L__RTCC_Read66
; temp end address is: 24 (R6)
;RTCC.c,201 :: 		DateTime->ss = My_Time.ss;
LDRB	R1, [SP, #4]
STRB	R1, [R5, #0]
;RTCC.c,202 :: 		DateTime->mn = My_Time.mn;
ADDS	R2, R5, #1
LDRB	R1, [SP, #5]
STRB	R1, [R2, #0]
;RTCC.c,203 :: 		DateTime->hh    = My_Time.hh;
ADDS	R2, R5, #2
LDRB	R1, [SP, #6]
STRB	R1, [R2, #0]
;RTCC.c,205 :: 		DateTime->md    = My_Time.md;
ADDS	R2, R5, #3
LDRB	R1, [SP, #7]
STRB	R1, [R2, #0]
;RTCC.c,206 :: 		DateTime->mo    = My_Time.mo;
ADDS	R2, R5, #5
LDRB	R1, [SP, #9]
STRB	R1, [R2, #0]
;RTCC.c,207 :: 		DateTime->yy    = My_Time.yy;
ADDS	R2, R5, #6
; DateTime end address is: 20 (R5)
LDRH	R1, [SP, #10]
STRH	R1, [R2, #0]
;RTCC.c,209 :: 		Old_RTC_Time = RTC_Time;
MOVW	R1, #lo_addr(_RTC_Time+0)
MOVT	R1, #hi_addr(_RTC_Time+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(_old_RTC_Time+0)
MOVT	R1, #hi_addr(_old_RTC_Time+0)
STR	R2, [R1, #0]
;RTCC.c,210 :: 		temp = 1;
; temp start address is: 0 (R0)
MOVS	R0, #1
; temp end address is: 0 (R0)
;RTCC.c,211 :: 		}
IT	AL
BAL	L_RTCC_Read14
L__RTCC_Read66:
;RTCC.c,200 :: 		if (RTC_Time != Old_RTC_Time) {
UXTB	R0, R6
;RTCC.c,211 :: 		}
L_RTCC_Read14:
;RTCC.c,212 :: 		return temp;
; temp start address is: 0 (R0)
; temp end address is: 0 (R0)
;RTCC.c,213 :: 		}
L_end_RTCC_Read:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _RTCC_Read
_DayOfWeek:
;RTCC.c,255 :: 		char DayOfWeek(unsigned yr, char mo, char dy) {
; dy start address is: 8 (R2)
; mo start address is: 4 (R1)
; yr start address is: 0 (R0)
; dy end address is: 8 (R2)
; mo end address is: 4 (R1)
; yr end address is: 0 (R0)
; yr start address is: 0 (R0)
; mo start address is: 4 (R1)
; dy start address is: 8 (R2)
;RTCC.c,258 :: 		if (mo < 3) {
CMP	R1, #3
IT	CS
BCS	L__DayOfWeek67
;RTCC.c,259 :: 		mo += 12;
ADDW	R3, R1, #12
UXTB	R1, R3
;RTCC.c,260 :: 		--yr;
SUBS	R0, R0, #1
UXTH	R0, R0
; yr end address is: 0 (R0)
; mo end address is: 4 (R1)
;RTCC.c,261 :: 		}
IT	AL
BAL	L_DayOfWeek15
L__DayOfWeek67:
;RTCC.c,258 :: 		if (mo < 3) {
;RTCC.c,261 :: 		}
L_DayOfWeek15:
;RTCC.c,264 :: 		dow = dy + (13 * mo - 27) / 5 + yr + yr/4 - yr/100 + yr/400;
; yr start address is: 0 (R0)
; mo start address is: 4 (R1)
MOVS	R3, #13
SXTH	R3, R3
MULS	R3, R1, R3
SXTH	R3, R3
; mo end address is: 4 (R1)
SUBW	R4, R3, #27
SXTH	R4, R4
MOVS	R3, #5
SXTH	R3, R3
SDIV	R3, R4, R3
SXTH	R3, R3
ADDS	R3, R2, R3
SXTH	R3, R3
; dy end address is: 8 (R2)
ADDS	R4, R3, R0
UXTH	R4, R4
LSRS	R3, R0, #2
UXTH	R3, R3
ADDS	R4, R4, R3
UXTH	R4, R4
MOVS	R3, #100
UDIV	R3, R0, R3
UXTH	R3, R3
SUB	R4, R4, R3
UXTH	R4, R4
MOVW	R3, #400
UDIV	R3, R0, R3
UXTH	R3, R3
; yr end address is: 0 (R0)
ADDS	R0, R4, R3
SXTH	R0, R0
; dow start address is: 0 (R0)
; dow end address is: 0 (R0)
;RTCC.c,265 :: 		while (dow < 0) dow += 7;
L_DayOfWeek16:
; dow start address is: 0 (R0)
CMP	R0, #0
IT	GE
BGE	L_DayOfWeek17
ADDS	R0, R0, #7
SXTH	R0, R0
IT	AL
BAL	L_DayOfWeek16
L_DayOfWeek17:
;RTCC.c,266 :: 		dow %= 7;
MOVS	R4, #7
SXTH	R4, R4
SDIV	R3, R0, R4
MLS	R3, R4, R3, R0
; dow end address is: 0 (R0)
;RTCC.c,267 :: 		return (char)dow;
UXTB	R0, R3
;RTCC.c,268 :: 		}
L_end_DayOfWeek:
BX	LR
; end of _DayOfWeek
_RTC_Initialize:
;RTCC.c,273 :: 		void RTC_Initialize(void) {
;RTCC.c,274 :: 		HIB_CTL_CLK32EN_bit = 1;            // Enable 32.768kHz oscillator
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(HIB_CTL_CLK32EN_bit+0)
MOVT	R0, #hi_addr(HIB_CTL_CLK32EN_bit+0)
STR	R1, [R0, #0]
;RTCC.c,275 :: 		}
L_end_RTC_Initialize:
BX	LR
; end of _RTC_Initialize
_RTC_StateMachine:
;RTCC.c,280 :: 		void RTC_StateMachine(void) {
SUB	SP, SP, #20
STR	LR, [SP, #0]
;RTCC.c,284 :: 		switch (RTC_State) {
IT	AL
BAL	L_RTC_StateMachine18
;RTCC.c,286 :: 		case 0: // Stay in this state until released by user
L_RTC_StateMachine20:
;RTCC.c,287 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,292 :: 		case 1:  // Wait here for write complete
L_RTC_StateMachine21:
;RTCC.c,293 :: 		if (HIB_CTL_WRC_bit)
MOVW	R1, #lo_addr(HIB_CTL_WRC_bit+0)
MOVT	R1, #hi_addr(HIB_CTL_WRC_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_RTC_StateMachine22
;RTCC.c,294 :: 		RTC_State = 2;
MOVS	R1, #2
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
L_RTC_StateMachine22:
;RTCC.c,295 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,297 :: 		case 2:  // Enable calendar mode
L_RTC_StateMachine23:
;RTCC.c,298 :: 		HIB_CALCTL_CALEN_bit =1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(HIB_CALCTL_CALEN_bit+0)
MOVT	R0, #hi_addr(HIB_CALCTL_CALEN_bit+0)
STR	R1, [R0, #0]
;RTCC.c,299 :: 		RTC_State = 3;
MOVS	R1, #3
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;RTCC.c,300 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,302 :: 		case 3:  // Wait here for write complete
L_RTC_StateMachine24:
;RTCC.c,303 :: 		if (HIB_CTL_WRC_bit)
MOVW	R1, #lo_addr(HIB_CTL_WRC_bit+0)
MOVT	R1, #hi_addr(HIB_CTL_WRC_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_RTC_StateMachine25
;RTCC.c,304 :: 		RTC_State = 4;
MOVS	R1, #4
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
L_RTC_StateMachine25:
;RTCC.c,305 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,307 :: 		case 4:  // Set 24 hour mode
L_RTC_StateMachine26:
;RTCC.c,308 :: 		HIB_CALCTL_CAL24_bit =1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(HIB_CALCTL_CAL24_bit+0)
MOVT	R0, #hi_addr(HIB_CALCTL_CAL24_bit+0)
STR	R1, [R0, #0]
;RTCC.c,309 :: 		RTC_State = 5;
MOVS	R1, #5
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;RTCC.c,310 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,312 :: 		case 5:  // Wait here for write complete
L_RTC_StateMachine27:
;RTCC.c,313 :: 		if (HIB_CTL_WRC_bit)
MOVW	R1, #lo_addr(HIB_CTL_WRC_bit+0)
MOVT	R1, #hi_addr(HIB_CTL_WRC_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_RTC_StateMachine28
;RTCC.c,314 :: 		RTC_State = 6;
MOVS	R1, #6
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
L_RTC_StateMachine28:
;RTCC.c,315 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,317 :: 		case 6:  // Disable RTC run
L_RTC_StateMachine29:
;RTCC.c,318 :: 		HIB_CTL_RTCEN_bit = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(HIB_CTL_RTCEN_bit+0)
MOVT	R0, #hi_addr(HIB_CTL_RTCEN_bit+0)
STR	R1, [R0, #0]
;RTCC.c,319 :: 		RTC_State = 7;
MOVS	R1, #7
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;RTCC.c,320 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,322 :: 		case 7:  // Start CC3000 State machine to get date and time
L_RTC_StateMachine30:
;RTCC.c,323 :: 		State = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_State+0)
MOVT	R0, #hi_addr(_State+0)
STRB	R1, [R0, #0]
;RTCC.c,324 :: 		RTC_State = 8;
MOVS	R1, #8
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;RTCC.c,325 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,327 :: 		case 8:  // Hold here until date/time obtained
L_RTC_StateMachine31:
;RTCC.c,328 :: 		if (State != 0 && ObtainedTime != TRUE) {
MOVW	R0, #lo_addr(_State+0)
MOVT	R0, #hi_addr(_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L__RTC_StateMachine70
MOVW	R0, #lo_addr(_ObtainedTime+0)
MOVT	R0, #hi_addr(_ObtainedTime+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	EQ
BEQ	L__RTC_StateMachine69
L__RTC_StateMachine68:
;RTCC.c,329 :: 		RTC_State = 8;
MOVS	R1, #8
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;RTCC.c,330 :: 		} else {
IT	AL
BAL	L_RTC_StateMachine35
;RTCC.c,328 :: 		if (State != 0 && ObtainedTime != TRUE) {
L__RTC_StateMachine70:
L__RTC_StateMachine69:
;RTCC.c,331 :: 		if (ObtainedTime == TRUE) {
MOVW	R0, #lo_addr(_ObtainedTime+0)
MOVT	R0, #hi_addr(_ObtainedTime+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_RTC_StateMachine36
;RTCC.c,332 :: 		TimeLoad = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_TimeLoad+0)
MOVT	R0, #hi_addr(_TimeLoad+0)
STR	R1, [R0, #0]
;RTCC.c,333 :: 		DateLoad = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_DateLoad+0)
MOVT	R0, #hi_addr(_DateLoad+0)
STR	R1, [R0, #0]
;RTCC.c,334 :: 		RTC_State = 9;
MOVS	R1, #9
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;RTCC.c,335 :: 		} else {
IT	AL
BAL	L_RTC_StateMachine37
L_RTC_StateMachine36:
;RTCC.c,336 :: 		UART1_PutQueue("Couldn't obtain time. Aborting...\r\n");
MOVW	R0, #lo_addr(?lstr1_RTCC+0)
MOVT	R0, #hi_addr(?lstr1_RTCC+0)
BL	_UART1_PutQueue+0
;RTCC.c,337 :: 		RTC_State = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;RTCC.c,338 :: 		}
L_RTC_StateMachine37:
;RTCC.c,339 :: 		}
L_RTC_StateMachine35:
;RTCC.c,340 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,342 :: 		case 9:  // Prepare time and date load
L_RTC_StateMachine38:
;RTCC.c,343 :: 		TimeLoad = (my_time.hh&0x1F);            // Set hours
MOVW	R0, #lo_addr(_my_time+2)
MOVT	R0, #hi_addr(_my_time+2)
LDRB	R0, [R0, #0]
AND	R0, R0, #31
UXTB	R0, R0
MOVW	R2, #lo_addr(_TimeLoad+0)
MOVT	R2, #hi_addr(_TimeLoad+0)
STR	R0, [R2, #0]
;RTCC.c,344 :: 		TimeLoad = (TimeLoad<<8);
MOV	R0, R2
LDR	R0, [R0, #0]
LSLS	R1, R0, #8
STR	R1, [R2, #0]
;RTCC.c,346 :: 		TimeLoad |= (my_time.mn&0x3F);           // Set minutes
MOVW	R0, #lo_addr(_my_time+1)
MOVT	R0, #hi_addr(_my_time+1)
LDRB	R0, [R0, #0]
AND	R0, R0, #63
UXTB	R0, R0
ORR	R0, R1, R0, LSL #0
STR	R0, [R2, #0]
;RTCC.c,347 :: 		TimeLoad = (TimeLoad<<8);
LSLS	R1, R0, #8
STR	R1, [R2, #0]
;RTCC.c,349 :: 		TimeLoad |= (my_time.ss&0x3F);           // Set seconds
MOVW	R0, #lo_addr(_my_time+0)
MOVT	R0, #hi_addr(_my_time+0)
LDRB	R0, [R0, #0]
AND	R0, R0, #63
UXTB	R0, R0
ORR	R0, R1, R0, LSL #0
STR	R0, [R2, #0]
;RTCC.c,352 :: 		UART1_PutQueue("Time load value: ");
MOVW	R0, #lo_addr(?lstr2_RTCC+0)
MOVT	R0, #hi_addr(?lstr2_RTCC+0)
BL	_UART1_PutQueue+0
;RTCC.c,353 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 28 (R7)
MOV	R7, R0
;RTCC.c,354 :: 		LongWordToHex(TimeLoad, BufNum);
MOVW	R1, #lo_addr(_TimeLoad+0)
MOVT	R1, #hi_addr(_TimeLoad+0)
LDR	R1, [R1, #0]
STR	R1, [SP, #4]
MOV	R1, R0
LDR	R0, [SP, #4]
BL	_LongWordToHex+0
;RTCC.c,355 :: 		strcat(BufNum,"\r\n");
MOVW	R0, #lo_addr(?lstr3_RTCC+0)
MOVT	R0, #hi_addr(?lstr3_RTCC+0)
MOV	R1, R0
MOV	R0, R7
BL	_strcat+0
;RTCC.c,356 :: 		UART1_PutQueue(BufNum);
MOV	R0, R7
; BufNum end address is: 28 (R7)
BL	_UART1_PutQueue+0
;RTCC.c,359 :: 		DoW = DayOfWeek(((my_time.yy-2000)&0x7F), (my_time.mo&0x0F), (my_time.md&0x1F));
MOVW	R0, #lo_addr(_my_time+3)
MOVT	R0, #hi_addr(_my_time+3)
STR	R0, [SP, #16]
LDRB	R0, [R0, #0]
AND	R2, R0, #31
MOVW	R0, #lo_addr(_my_time+5)
MOVT	R0, #hi_addr(_my_time+5)
LDRB	R0, [R0, #0]
AND	R1, R0, #15
MOVW	R0, #lo_addr(_my_time+6)
MOVT	R0, #hi_addr(_my_time+6)
STR	R0, [SP, #12]
LDRH	R0, [R0, #0]
SUB	R0, R0, #2000
UXTH	R0, R0
AND	R0, R0, #127
BL	_DayOfWeek+0
MOVW	R1, #lo_addr(_DoW+0)
MOVT	R1, #hi_addr(_DoW+0)
STRB	R0, [R1, #0]
;RTCC.c,361 :: 		DateLoad = DoW;                          // Set day-of-week
MOVW	R2, #lo_addr(_DateLoad+0)
MOVT	R2, #hi_addr(_DateLoad+0)
STR	R2, [SP, #8]
STR	R0, [R2, #0]
;RTCC.c,362 :: 		DateLoad = (DateLoad<<8);
MOV	R0, R2
LDR	R0, [R0, #0]
LSLS	R1, R0, #8
STR	R1, [R2, #0]
;RTCC.c,364 :: 		DateLoad |= ((my_time.yy-2000)&0x7F);    // Set year
LDR	R0, [SP, #12]
LDRH	R0, [R0, #0]
SUB	R0, R0, #2000
UXTH	R0, R0
AND	R0, R0, #127
UXTH	R0, R0
ORR	R0, R1, R0, LSL #0
STR	R0, [R2, #0]
;RTCC.c,365 :: 		DateLoad = (DateLoad<<8);
LSLS	R0, R0, #8
STR	R0, [R2, #0]
;RTCC.c,368 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;RTCC.c,369 :: 		sprintf(BufNum,"Year is: %d\r\n",my_time.yy);
MOVW	R1, #lo_addr(_my_time+6)
MOVT	R1, #hi_addr(_my_time+6)
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_4_RTCC+0)
MOVT	R1, #hi_addr(?lstr_4_RTCC+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;RTCC.c,370 :: 		UART1_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_UART1_PutQueue+0
;RTCC.c,372 :: 		DateLoad |= (my_time.mo&0x0F);           // Set month
MOVW	R0, #lo_addr(_my_time+5)
MOVT	R0, #hi_addr(_my_time+5)
LDRB	R0, [R0, #0]
AND	R2, R0, #15
UXTB	R2, R2
MOVW	R1, #lo_addr(_DateLoad+0)
MOVT	R1, #hi_addr(_DateLoad+0)
LDR	R0, [R1, #0]
ORRS	R0, R2
STR	R0, [R1, #0]
;RTCC.c,373 :: 		DateLoad = (DateLoad<<8);
LSLS	R2, R0, #8
LDR	R1, [SP, #8]
STR	R2, [R1, #0]
;RTCC.c,375 :: 		DateLoad |= (my_time.md&0x1F);           // Set day
LDR	R0, [SP, #16]
LDRB	R0, [R0, #0]
AND	R0, R0, #31
UXTB	R0, R0
ORR	R0, R2, R0, LSL #0
STR	R0, [R1, #0]
;RTCC.c,378 :: 		UART1_PutQueue("Date load value: ");
MOVW	R0, #lo_addr(?lstr5_RTCC+0)
MOVT	R0, #hi_addr(?lstr5_RTCC+0)
BL	_UART1_PutQueue+0
;RTCC.c,379 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 28 (R7)
MOV	R7, R0
;RTCC.c,380 :: 		LongWordToHex(DateLoad, BufNum);
MOVW	R1, #lo_addr(_DateLoad+0)
MOVT	R1, #hi_addr(_DateLoad+0)
LDR	R1, [R1, #0]
STR	R1, [SP, #4]
MOV	R1, R0
LDR	R0, [SP, #4]
BL	_LongWordToHex+0
;RTCC.c,381 :: 		strcat(BufNum,"\r\n");
MOVW	R0, #lo_addr(?lstr6_RTCC+0)
MOVT	R0, #hi_addr(?lstr6_RTCC+0)
MOV	R1, R0
MOV	R0, R7
BL	_strcat+0
;RTCC.c,382 :: 		UART1_PutQueue(BufNum);
MOV	R0, R7
; BufNum end address is: 28 (R7)
BL	_UART1_PutQueue+0
;RTCC.c,384 :: 		RTC_State = 10;
MOVS	R1, #10
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;RTCC.c,385 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,387 :: 		case 10:  // Wait here for write complete
L_RTC_StateMachine39:
;RTCC.c,388 :: 		if (HIB_CTL_WRC_bit)
MOVW	R1, #lo_addr(HIB_CTL_WRC_bit+0)
MOVT	R1, #hi_addr(HIB_CTL_WRC_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_RTC_StateMachine40
;RTCC.c,389 :: 		RTC_State = 11;
MOVS	R1, #11
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
L_RTC_StateMachine40:
;RTCC.c,390 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,392 :: 		case 11:  // Write calendar register for time
L_RTC_StateMachine41:
;RTCC.c,393 :: 		HIB_CALLD0 = TimeLoad;
MOVW	R0, #lo_addr(_TimeLoad+0)
MOVT	R0, #hi_addr(_TimeLoad+0)
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(HIB_CALLD0+0)
MOVT	R0, #hi_addr(HIB_CALLD0+0)
STR	R1, [R0, #0]
;RTCC.c,394 :: 		RTC_State = 12;
MOVS	R1, #12
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;RTCC.c,395 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,397 :: 		case 12:  // Wait here for write complete
L_RTC_StateMachine42:
;RTCC.c,398 :: 		if (HIB_CTL_WRC_bit)
MOVW	R1, #lo_addr(HIB_CTL_WRC_bit+0)
MOVT	R1, #hi_addr(HIB_CTL_WRC_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_RTC_StateMachine43
;RTCC.c,399 :: 		RTC_State = 13;
MOVS	R1, #13
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
L_RTC_StateMachine43:
;RTCC.c,400 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,402 :: 		case 13:  // Write calendar register for date
L_RTC_StateMachine44:
;RTCC.c,403 :: 		HIB_CALLD1 = DateLoad;
MOVW	R0, #lo_addr(_DateLoad+0)
MOVT	R0, #hi_addr(_DateLoad+0)
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(HIB_CALLD1+0)
MOVT	R0, #hi_addr(HIB_CALLD1+0)
STR	R1, [R0, #0]
;RTCC.c,404 :: 		RTC_State = 14;
MOVS	R1, #14
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;RTCC.c,405 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,407 :: 		case 14:  // Wait here for write complete
L_RTC_StateMachine45:
;RTCC.c,408 :: 		if (HIB_CTL_WRC_bit)
MOVW	R1, #lo_addr(HIB_CTL_WRC_bit+0)
MOVT	R1, #hi_addr(HIB_CTL_WRC_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_RTC_StateMachine46
;RTCC.c,409 :: 		RTC_State = 15;
MOVS	R1, #15
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
L_RTC_StateMachine46:
;RTCC.c,410 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,412 :: 		case 15:  // Enable RTC run
L_RTC_StateMachine47:
;RTCC.c,413 :: 		HIB_CTL_RTCEN_bit = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(HIB_CTL_RTCEN_bit+0)
MOVT	R0, #hi_addr(HIB_CTL_RTCEN_bit+0)
STR	R1, [R0, #0]
;RTCC.c,414 :: 		UART1_PutQueue("RTC set\r\n");
MOVW	R0, #lo_addr(?lstr7_RTCC+0)
MOVT	R0, #hi_addr(?lstr7_RTCC+0)
BL	_UART1_PutQueue+0
;RTCC.c,415 :: 		RTC_State = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;RTCC.c,416 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,421 :: 		case 16:  // Read time register
L_RTC_StateMachine48:
;RTCC.c,422 :: 		TimeRead = HIB_CAL0;
MOVW	R0, #lo_addr(HIB_CAL0+0)
MOVT	R0, #hi_addr(HIB_CAL0+0)
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(_TimeRead+0)
MOVT	R0, #hi_addr(_TimeRead+0)
STR	R1, [R0, #0]
;RTCC.c,423 :: 		DateRead = HIB_CAL1;
MOVW	R0, #lo_addr(HIB_CAL1+0)
MOVT	R0, #hi_addr(HIB_CAL1+0)
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(_DateRead+0)
MOVT	R0, #hi_addr(_DateRead+0)
STR	R1, [R0, #0]
;RTCC.c,425 :: 		UART1_PutQueue("Time read: ");
MOVW	R0, #lo_addr(?lstr8_RTCC+0)
MOVT	R0, #hi_addr(?lstr8_RTCC+0)
BL	_UART1_PutQueue+0
;RTCC.c,426 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 28 (R7)
MOV	R7, R0
;RTCC.c,427 :: 		LongWordToHex(TimeRead, BufNum);
MOVW	R1, #lo_addr(_TimeRead+0)
MOVT	R1, #hi_addr(_TimeRead+0)
LDR	R1, [R1, #0]
STR	R1, [SP, #4]
MOV	R1, R0
LDR	R0, [SP, #4]
BL	_LongWordToHex+0
;RTCC.c,428 :: 		strcat(BufNum,"\r\n");
MOVW	R0, #lo_addr(?lstr9_RTCC+0)
MOVT	R0, #hi_addr(?lstr9_RTCC+0)
MOV	R1, R0
MOV	R0, R7
BL	_strcat+0
;RTCC.c,429 :: 		UART1_PutQueue(BufNum);
MOV	R0, R7
; BufNum end address is: 28 (R7)
BL	_UART1_PutQueue+0
;RTCC.c,431 :: 		UART1_PutQueue("Date read: ");
MOVW	R0, #lo_addr(?lstr10_RTCC+0)
MOVT	R0, #hi_addr(?lstr10_RTCC+0)
BL	_UART1_PutQueue+0
;RTCC.c,432 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 28 (R7)
MOV	R7, R0
;RTCC.c,433 :: 		LongWordToHex(DateRead, BufNum);
MOVW	R1, #lo_addr(_DateRead+0)
MOVT	R1, #hi_addr(_DateRead+0)
LDR	R1, [R1, #0]
STR	R1, [SP, #4]
MOV	R1, R0
LDR	R0, [SP, #4]
BL	_LongWordToHex+0
;RTCC.c,434 :: 		strcat(BufNum,"\r\n");
MOVW	R0, #lo_addr(?lstr11_RTCC+0)
MOVT	R0, #hi_addr(?lstr11_RTCC+0)
MOV	R1, R0
MOV	R0, R7
BL	_strcat+0
;RTCC.c,435 :: 		UART1_PutQueue(BufNum);
MOV	R0, R7
; BufNum end address is: 28 (R7)
BL	_UART1_PutQueue+0
;RTCC.c,437 :: 		RTC_State = 17;
MOVS	R1, #17
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;RTCC.c,438 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,440 :: 		case 17:
L_RTC_StateMachine49:
;RTCC.c,441 :: 		Yr = (char)(DateRead >> 16);
MOVW	R2, #lo_addr(_DateRead+0)
MOVT	R2, #hi_addr(_DateRead+0)
LDR	R0, [R2, #0]
LSRS	R0, R0, #16
UXTB	R0, R0
MOVW	R1, #lo_addr(_Yr+0)
MOVT	R1, #hi_addr(_Yr+0)
STR	R1, [SP, #16]
STRH	R0, [R1, #0]
;RTCC.c,442 :: 		Yr += 2000;
MOV	R0, R1
LDRH	R0, [R0, #0]
ADD	R0, R0, #2000
STRH	R0, [R1, #0]
;RTCC.c,443 :: 		Mo = DateRead >> 8;
MOV	R0, R2
LDR	R0, [R0, #0]
LSRS	R1, R0, #8
MOVW	R0, #lo_addr(_Mo+0)
MOVT	R0, #hi_addr(_Mo+0)
STR	R0, [SP, #12]
STRB	R1, [R0, #0]
;RTCC.c,444 :: 		Da = DateRead;
MOV	R0, R2
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(_Da+0)
MOVT	R0, #hi_addr(_Da+0)
STR	R0, [SP, #8]
STRB	R1, [R0, #0]
;RTCC.c,446 :: 		Hr = TimeRead >> 16;
MOVW	R2, #lo_addr(_TimeRead+0)
MOVT	R2, #hi_addr(_TimeRead+0)
LDR	R0, [R2, #0]
LSRS	R1, R0, #16
MOVW	R0, #lo_addr(_Hr+0)
MOVT	R0, #hi_addr(_Hr+0)
STRB	R1, [R0, #0]
;RTCC.c,447 :: 		Mn = TimeRead >> 8;
MOV	R0, R2
LDR	R0, [R0, #0]
LSRS	R1, R0, #8
MOVW	R0, #lo_addr(_Mn+0)
MOVT	R0, #hi_addr(_Mn+0)
STRB	R1, [R0, #0]
;RTCC.c,448 :: 		Se = TimeRead;
MOV	R0, R2
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(_Se+0)
MOVT	R0, #hi_addr(_Se+0)
STRB	R1, [R0, #0]
;RTCC.c,450 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 32 (R8)
MOV	R8, R0
;RTCC.c,451 :: 		sprintf(BufNum,"Date: %d/%d/%d  Time: %d:%02d:%02d\r\n",Yr,Mo,Da,Hr,Mn,Se);
MOVW	R1, #lo_addr(_Se+0)
MOVT	R1, #hi_addr(_Se+0)
LDRB	R7, [R1, #0]
MOVW	R1, #lo_addr(_Mn+0)
MOVT	R1, #hi_addr(_Mn+0)
LDRB	R6, [R1, #0]
MOVW	R1, #lo_addr(_Hr+0)
MOVT	R1, #hi_addr(_Hr+0)
LDRB	R5, [R1, #0]
MOVW	R1, #lo_addr(_Da+0)
MOVT	R1, #hi_addr(_Da+0)
LDRB	R4, [R1, #0]
MOVW	R1, #lo_addr(_Mo+0)
MOVT	R1, #hi_addr(_Mo+0)
LDRB	R3, [R1, #0]
MOVW	R1, #lo_addr(_Yr+0)
MOVT	R1, #hi_addr(_Yr+0)
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_12_RTCC+0)
MOVT	R1, #hi_addr(?lstr_12_RTCC+0)
STR	R8, [SP, #4]
PUSH	(R7)
PUSH	(R6)
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #32
LDR	R8, [SP, #4]
;RTCC.c,452 :: 		UART1_PutQueue(BufNum);
MOV	R0, R8
; BufNum end address is: 32 (R8)
BL	_UART1_PutQueue+0
;RTCC.c,453 :: 		RTC_State = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;RTCC.c,455 :: 		DoW = DayOfWeek(Yr, Mo, Da);
LDR	R0, [SP, #8]
LDRB	R2, [R0, #0]
LDR	R0, [SP, #12]
LDRB	R1, [R0, #0]
LDR	R0, [SP, #16]
LDRH	R0, [R0, #0]
BL	_DayOfWeek+0
MOVW	R1, #lo_addr(_DoW+0)
MOVT	R1, #hi_addr(_DoW+0)
STRB	R0, [R1, #0]
;RTCC.c,457 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;RTCC.c,458 :: 		sprintf(BufNum,"DoW: %d\r\n",DoW);
MOVW	R1, #lo_addr(_DoW+0)
MOVT	R1, #hi_addr(_DoW+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_13_RTCC+0)
MOVT	R1, #hi_addr(?lstr_13_RTCC+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;RTCC.c,459 :: 		UART1_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_UART1_PutQueue+0
;RTCC.c,461 :: 		RTC_State = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;RTCC.c,462 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,467 :: 		case 18:  // Wait here for write complete
L_RTC_StateMachine50:
;RTCC.c,468 :: 		if (HIB_CTL_WRC_bit)
MOVW	R1, #lo_addr(HIB_CTL_WRC_bit+0)
MOVT	R1, #hi_addr(HIB_CTL_WRC_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_RTC_StateMachine51
;RTCC.c,469 :: 		RTC_State = 19;
MOVS	R1, #19
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
L_RTC_StateMachine51:
;RTCC.c,470 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,472 :: 		case 19:  // Enable calendar mode
L_RTC_StateMachine52:
;RTCC.c,473 :: 		HIB_CALCTL_CALEN_bit =1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(HIB_CALCTL_CALEN_bit+0)
MOVT	R0, #hi_addr(HIB_CALCTL_CALEN_bit+0)
STR	R1, [R0, #0]
;RTCC.c,474 :: 		RTC_State = 20;
MOVS	R1, #20
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;RTCC.c,475 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,477 :: 		case 20:  // Wait here for write complete
L_RTC_StateMachine53:
;RTCC.c,478 :: 		if (HIB_CTL_WRC_bit)
MOVW	R1, #lo_addr(HIB_CTL_WRC_bit+0)
MOVT	R1, #hi_addr(HIB_CTL_WRC_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_RTC_StateMachine54
;RTCC.c,479 :: 		RTC_State = 21;
MOVS	R1, #21
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
L_RTC_StateMachine54:
;RTCC.c,480 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,482 :: 		case 21:  // Set 24 hour mode
L_RTC_StateMachine55:
;RTCC.c,483 :: 		HIB_CALCTL_CAL24_bit =1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(HIB_CALCTL_CAL24_bit+0)
MOVT	R0, #hi_addr(HIB_CALCTL_CAL24_bit+0)
STR	R1, [R0, #0]
;RTCC.c,484 :: 		RTC_State = 22;
MOVS	R1, #22
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;RTCC.c,485 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,487 :: 		case 22:  // Wait here for write complete
L_RTC_StateMachine56:
;RTCC.c,488 :: 		if (HIB_CTL_WRC_bit)
MOVW	R1, #lo_addr(HIB_CTL_WRC_bit+0)
MOVT	R1, #hi_addr(HIB_CTL_WRC_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_RTC_StateMachine57
;RTCC.c,489 :: 		RTC_State = 23;
MOVS	R1, #23
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
L_RTC_StateMachine57:
;RTCC.c,490 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,492 :: 		case 23:  // Disable RTC run
L_RTC_StateMachine58:
;RTCC.c,493 :: 		HIB_CTL_RTCEN_bit = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(HIB_CTL_RTCEN_bit+0)
MOVT	R0, #hi_addr(HIB_CTL_RTCEN_bit+0)
STR	R1, [R0, #0]
;RTCC.c,494 :: 		RTC_State = 24;
MOVS	R1, #24
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;RTCC.c,495 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,497 :: 		case 24:  // Wait here for write complete
L_RTC_StateMachine59:
;RTCC.c,498 :: 		if (HIB_CTL_WRC_bit)
MOVW	R1, #lo_addr(HIB_CTL_WRC_bit+0)
MOVT	R1, #hi_addr(HIB_CTL_WRC_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_RTC_StateMachine60
;RTCC.c,499 :: 		RTC_State = 25;
MOVS	R1, #25
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
L_RTC_StateMachine60:
;RTCC.c,500 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,502 :: 		case 25:  // Write calendar register for time
L_RTC_StateMachine61:
;RTCC.c,503 :: 		HIB_CALLD0 = 0x000D091C;
MOVW	R1, #2332
MOVT	R1, #13
MOVW	R0, #lo_addr(HIB_CALLD0+0)
MOVT	R0, #hi_addr(HIB_CALLD0+0)
STR	R1, [R0, #0]
;RTCC.c,504 :: 		RTC_State = 26;
MOVS	R1, #26
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;RTCC.c,505 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,507 :: 		case 26:  // Wait here for write complete
L_RTC_StateMachine62:
;RTCC.c,508 :: 		if (HIB_CTL_WRC_bit)
MOVW	R1, #lo_addr(HIB_CTL_WRC_bit+0)
MOVT	R1, #hi_addr(HIB_CTL_WRC_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_RTC_StateMachine63
;RTCC.c,509 :: 		RTC_State = 27;
MOVS	R1, #27
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
L_RTC_StateMachine63:
;RTCC.c,510 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,512 :: 		case 27:  // Write calendar register for date
L_RTC_StateMachine64:
;RTCC.c,513 :: 		HIB_CALLD1 = 0x000F0405;
MOVW	R1, #1029
MOVT	R1, #15
MOVW	R0, #lo_addr(HIB_CALLD1+0)
MOVT	R0, #hi_addr(HIB_CALLD1+0)
STR	R1, [R0, #0]
;RTCC.c,514 :: 		RTC_State = 28;
MOVS	R1, #28
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;RTCC.c,515 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,517 :: 		case 28:
L_RTC_StateMachine65:
;RTCC.c,518 :: 		UART1_PutQueue("Test complete\r\n");
MOVW	R0, #lo_addr(?lstr14_RTCC+0)
MOVT	R0, #hi_addr(?lstr14_RTCC+0)
BL	_UART1_PutQueue+0
;RTCC.c,519 :: 		RTC_State = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
STRB	R1, [R0, #0]
;RTCC.c,520 :: 		break;
IT	AL
BAL	L_RTC_StateMachine19
;RTCC.c,522 :: 		}
L_RTC_StateMachine18:
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_RTC_StateMachine20
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	EQ
BEQ	L_RTC_StateMachine21
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #2
IT	EQ
BEQ	L_RTC_StateMachine23
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #3
IT	EQ
BEQ	L_RTC_StateMachine24
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #4
IT	EQ
BEQ	L_RTC_StateMachine26
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #5
IT	EQ
BEQ	L_RTC_StateMachine27
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #6
IT	EQ
BEQ	L_RTC_StateMachine29
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #7
IT	EQ
BEQ	L_RTC_StateMachine30
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #8
IT	EQ
BEQ	L_RTC_StateMachine31
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #9
IT	EQ
BEQ	L_RTC_StateMachine38
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #10
IT	EQ
BEQ	L_RTC_StateMachine39
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #11
IT	EQ
BEQ	L_RTC_StateMachine41
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #12
IT	EQ
BEQ	L_RTC_StateMachine42
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #13
IT	EQ
BEQ	L_RTC_StateMachine44
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #14
IT	EQ
BEQ	L_RTC_StateMachine45
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #15
IT	EQ
BEQ	L_RTC_StateMachine47
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #16
IT	EQ
BEQ	L_RTC_StateMachine48
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #17
IT	EQ
BEQ	L_RTC_StateMachine49
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #18
IT	EQ
BEQ	L_RTC_StateMachine50
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #19
IT	EQ
BEQ	L_RTC_StateMachine52
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #20
IT	EQ
BEQ	L_RTC_StateMachine53
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #21
IT	EQ
BEQ	L_RTC_StateMachine55
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #22
IT	EQ
BEQ	L_RTC_StateMachine56
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #23
IT	EQ
BEQ	L_RTC_StateMachine58
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #24
IT	EQ
BEQ	L_RTC_StateMachine59
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #25
IT	EQ
BEQ	L_RTC_StateMachine61
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #26
IT	EQ
BEQ	L_RTC_StateMachine62
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #27
IT	EQ
BEQ	L_RTC_StateMachine64
MOVW	R0, #lo_addr(_RTC_State+0)
MOVT	R0, #hi_addr(_RTC_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #28
IT	EQ
BEQ	L_RTC_StateMachine65
L_RTC_StateMachine19:
;RTCC.c,523 :: 		}
L_end_RTC_StateMachine:
LDR	LR, [SP, #0]
ADD	SP, SP, #20
BX	LR
; end of _RTC_StateMachine
