/**************************************************************************************************
  RTCC.h
  Driver for Wi-Fi chip.
**************************************************************************************************/
#ifndef RTCC_H
#define RTCC_H

#include "__Time.h"


/* Not using this structure
// Typedefs
typedef struct Time {
     short ampm;
     short seconds;
     short minutes;
     short hours;
     short day;
     short month;
     int   year;
} TTime;
*/




// Function prototypes
void HibernateRTCDisable(void);
void HibernateRTCEnable(void);
void HibernateRTCSet(TimeStruct *temp);
unsigned long HibernateRTCGet(TimeStruct *temp);

char DayOfWeek(unsigned yr, char mo, char dy);
void RTC_Init(void);
void Set_RTC(TimeStruct *DateTime);
char RTCC_Read(TimeStruct *DateTime);

void RTC_Initialize(void);
void RTC_StateMachine(void);


#endif